// This is the main DLL file.

#include "stdafx.h"

#include "SomeClass.h"

namespace CLRLibInNativeApp
{
	namespace NativeToCLRWrapperLibrary
	{

		class SomeClassImplementation
		{
		private:
			
			gcroot<CLRLibrary::SomeClass ^> clrInstance;

		public:
			
			SomeClassImplementation():
				clrInstance(gcnew CLRLibrary::SomeClass())
			{
			}
			
			void SomeMethod()
			{
				this->clrInstance->SomeMethod();
			}

		};

		SomeClass::SomeClass():
			instance(new SomeClassImplementation())
		{
		}

		void SomeClass::SomeMethod()
		{
			this->instance->SomeMethod();
		}

		SomeClass::~SomeClass()
		{
			delete this->instance;
		}

	}
}